/*

CaesarCrypt v1.0
Written By: E-HACK (epicurus@wilter.com)

A simple example program to perform the "Caesar Cipher", an old, insecure
encryption scheme. Can both encrypt and decrypt files. Not reccomended for
anything other than novelty and/or study. This encryption algorythm is very
easy to break even without a program to use.


With the Caesar Cipher, each letter is moved over X spaces, much like the
old "decoder rings" that you used to be able to get by sending in box tops
and crap in the 50's. 

This isn't exactly the Caesar Cipher, as I've added cases (usually it's only
upper or lower case) and numbers to the things to be encrypted, also, any
non alpha-numeric charicters are retained. You could say this is better than
the Caesar Cipher, but I wouldn't say it's any more secure.

This program is copylefted, so you can do whatever you want with it, so have
some fun, but please, don't use this for anything important, as it's simply
secure enough.

Disclaimer:
THIS PROGRAM IS DISTRIBUTED "AS IS," WITHOUT ANY IMPLIED OR EXPRESS WARRANTY
AS TO ITS PERFORMANCE OR AS TO THE RESULTS THAT MAY BE OBTAINED BY ITS USE.
E-HACK AND WILTERED FIRE ARE NOT LIABLE FOR DIRECT, INDIRECT, OR INCIDENTAL
DAMAGES FROM ANY DEFECT, MALFUNCTION, INABLILITY OR OMISSION IN THE SOFTWARE
OR MANUAL OR OTHER RELATED ITEMS AND PROCESSES, INCLUDING BUT NOT LIMITED TO
SERVICE, LOSS OF BUSINESS, ANTICIPATED PROFIT, OR OTHER CONSEQUENTIAL DAMAGES.

*/



#include <stdio.h> // standard I/O functions
#include <string.h> // for the string compares needed

// all the charicters that this will encrypt/decrypt
static char *letters[] = {  "a","b","c","d","e","f","g","h","i","j","k","l","m",
			"n","o","p","q","r","s","t","u","v","w","x","y","z","A",
			"B","C","D","E","F","G","H","I","J","K","L","M","N","O",
			"P","Q","R","S","T","U","V","W","X","Y","Z","0","1","2",
			"3","4","5","6","7","8","9" };

// this charicter is appended to files for some reason, this is here to make it stop doin' that.
// if this charicter is actually part of the file you're encrypting, it could cause some problems.
static char *wtf = "";

// Version crap, printed in the main() function. Dunno why I did it like this, just for the hell of it I guess.
static char *version = "CaesarCrypt v1.0\nWritten By: E-HACK\n\n";


int main(void)
{
char infile[256], outfile[256], charicter[1], *printletter, enc[1];
int c, i, enci, key, let;
FILE *ffp, *sfp;

printf("%s", version);
printf("Input File: ");
scanf("%s", infile); // gets the input file, it'll be opened as ffp
printf("Output File: ");
scanf("%s", outfile); // gets the output file, it'll be opened as sfp
printf("Key: ");
scanf("%d", &key); // gets the key to use for encryption/decryption

// force the key to be between 0 and 61, otherwise funky shit can happen
while(key > 61){ key = key - 62; }
while(key < 0) { key = key + 62; }

// ask if they need to decrypt or encrypt
printf("Encrypt or Decrypt(E/D)? ");
scanf("%s", enc);
enci = 0;
if(strcmpi(enc,"decrypt") == 0){
enci = 1;
}
if(strcmpi(enc,"d") == 0){
enci = 1;
}

// open the input file
ffp = fopen(infile, "r");
	if(ffp == NULL) {
        // oops, can't open that one, it's not there
	printf("Unable to open %s!", infile);
	return(0);
	}
// open the output file
sfp = fopen(outfile, "w");
// flush the contents of the output file
fflush(sfp);

// do this for every byte in the input file
while(c != EOF)
{
// get one byte from the input file
c = getc(ffp);
// set charicter[0] (all of charicter since charicter is only 1 byte long) to the byte c got
charicter[0] = c;

// this is here in case the charicter isn't a-z-A-z-0-9
i = 111;

// test the charicter against all the letters/numbers in the letters array
// jump out of the loop if the charicter matches.
let = 0;
while(let < 62)
{
	if(strcmp(charicter,letters[let]) == 0) {
	i = let;
	let = 62;
	}
let++;
}

if(i == 111){

// check for that funky y charicter
if(strcmp(charicter,wtf) != 0){
printletter = charicter;
}
else{
printletter = "";
}

}
else
{
// if enci == 1, we're decrypting
if(enci == 1)
{
i = i - key;
}
if(enci != 1)
{
i = i + key;
}
// get i between 0 and 61 again
while(i > 61){ i = i - 62; }
while(i < 0) { i = i + 62; }
printletter = letters[i];
}
// print the encrypted charicter to the output file
fprintf(sfp, "%s", printletter);
}
// close input and output files
fclose(ffp);
fclose(sfp);

// delete the input file...I decided to comment this out though
// unlink(infile);

// tell the user that we're done encrypting or decrypting the data
if(enci == 1){
printf("Decrypted %s to %s", infile, outfile);
}
else {
printf("Encrypted %s to %s", infile, outfile);
}

// make the program quit.
return(0);
}